/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { AcceptedLanguage } from '../../@coscine/model';
// @ts-ignore
import type { VocabularyDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { VocabularyInstanceDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { VocabularyInstanceDtoResponse } from '../../@coscine/model';
/**
 * VocabularyApi - axios parameter creator
 * @export
 */
export const VocabularyApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2VocabulariesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/vocabularies`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves top-level instances from vocabularies.
         * @param {string} [searchTerm] Gets or sets the search term used to filter vocabularies.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the vocabularies are requested.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularies: async (searchTerm?: string, language?: AcceptedLanguage, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/vocabularies`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (searchTerm !== undefined) {
                localVarQueryParameter['SearchTerm'] = searchTerm;
            }

            if (language !== undefined) {
                localVarQueryParameter['Language'] = language;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Could be a top-level instance, or an intermediate-level instance from a vocabulary.
         * @summary Retrieves a single instance from a vocabulary.
         * @param {string} instance The URI of the vocabulary instance to retrieve.
         * @param {AcceptedLanguage} [acceptLanguage] The preferred language for the instance data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularyInstance: async (instance: string, acceptLanguage?: AcceptedLanguage, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'instance' is not null or undefined
            assertParamExists('getVocabularyInstance', 'instance', instance)
            const localVarPath = `/api/v2/vocabularies/instances/{instance}`
                .replace(`{${"instance"}}`, encodeURIComponent(String(instance)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            if (acceptLanguage != null) {
                localVarHeaderParameter['Accept-Language'] = typeof acceptLanguage === 'string'
                    ? acceptLanguage
                    : JSON.stringify(acceptLanguage);
            }
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves vocabulary instances.
         * @param {string} _class Gets or sets the URI class, which is a required field.
         * @param {string} [searchTerm] Gets or sets the search term used to filter vocabulary instances.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the vocabulary instances are requested.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;150&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularyInstances: async (_class: string, searchTerm?: string, language?: AcceptedLanguage, pageSize?: number, pageNumber?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter '_class' is not null or undefined
            assertParamExists('getVocabularyInstances', '_class', _class)
            const localVarPath = `/api/v2/vocabularies/instances`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (_class !== undefined) {
                localVarQueryParameter['Class'] = _class;
            }

            if (searchTerm !== undefined) {
                localVarQueryParameter['SearchTerm'] = searchTerm;
            }

            if (language !== undefined) {
                localVarQueryParameter['Language'] = language;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VocabularyApi - functional programming interface
 * @export
 */
export const VocabularyApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = VocabularyApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2VocabulariesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2VocabulariesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VocabularyApi.apiV2VocabulariesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves top-level instances from vocabularies.
         * @param {string} [searchTerm] Gets or sets the search term used to filter vocabularies.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the vocabularies are requested.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getVocabularies(searchTerm?: string, language?: AcceptedLanguage, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VocabularyDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getVocabularies(searchTerm, language, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VocabularyApi.getVocabularies']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * Could be a top-level instance, or an intermediate-level instance from a vocabulary.
         * @summary Retrieves a single instance from a vocabulary.
         * @param {string} instance The URI of the vocabulary instance to retrieve.
         * @param {AcceptedLanguage} [acceptLanguage] The preferred language for the instance data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getVocabularyInstance(instance: string, acceptLanguage?: AcceptedLanguage, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VocabularyInstanceDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getVocabularyInstance(instance, acceptLanguage, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VocabularyApi.getVocabularyInstance']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves vocabulary instances.
         * @param {string} _class Gets or sets the URI class, which is a required field.
         * @param {string} [searchTerm] Gets or sets the search term used to filter vocabulary instances.
         * @param {AcceptedLanguage} [language] Gets or sets the language for which the vocabulary instances are requested.
         * @param {number} [pageSize] Number of items per page. The maximum number of items per page is &#x60;150&#x60;.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getVocabularyInstances(_class: string, searchTerm?: string, language?: AcceptedLanguage, pageSize?: number, pageNumber?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<VocabularyInstanceDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getVocabularyInstances(_class, searchTerm, language, pageSize, pageNumber, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['VocabularyApi.getVocabularyInstances']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * VocabularyApi - factory interface
 * @export
 */
export const VocabularyApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = VocabularyApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2VocabulariesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2VocabulariesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves top-level instances from vocabularies.
         * @param {VocabularyApiGetVocabulariesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularies(requestParameters: VocabularyApiGetVocabulariesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<VocabularyDtoPagedResponse> {
            return localVarFp.getVocabularies(requestParameters.searchTerm, requestParameters.language, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * Could be a top-level instance, or an intermediate-level instance from a vocabulary.
         * @summary Retrieves a single instance from a vocabulary.
         * @param {VocabularyApiGetVocabularyInstanceRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularyInstance(requestParameters: VocabularyApiGetVocabularyInstanceRequest, options?: RawAxiosRequestConfig): AxiosPromise<VocabularyInstanceDtoResponse> {
            return localVarFp.getVocabularyInstance(requestParameters.instance, requestParameters.acceptLanguage, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves vocabulary instances.
         * @param {VocabularyApiGetVocabularyInstancesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getVocabularyInstances(requestParameters: VocabularyApiGetVocabularyInstancesRequest, options?: RawAxiosRequestConfig): AxiosPromise<VocabularyInstanceDtoPagedResponse> {
            return localVarFp.getVocabularyInstances(requestParameters._class, requestParameters.searchTerm, requestParameters.language, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getVocabularies operation in VocabularyApi.
 * @export
 * @interface VocabularyApiGetVocabulariesRequest
 */
export interface VocabularyApiGetVocabulariesRequest {
    /**
     * Gets or sets the search term used to filter vocabularies.
     * @type {string}
     * @memberof VocabularyApiGetVocabularies
     */
    readonly searchTerm?: string

    /**
     * Gets or sets the language for which the vocabularies are requested.
     * @type {AcceptedLanguage}
     * @memberof VocabularyApiGetVocabularies
     */
    readonly language?: AcceptedLanguage

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof VocabularyApiGetVocabularies
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof VocabularyApiGetVocabularies
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof VocabularyApiGetVocabularies
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getVocabularyInstance operation in VocabularyApi.
 * @export
 * @interface VocabularyApiGetVocabularyInstanceRequest
 */
export interface VocabularyApiGetVocabularyInstanceRequest {
    /**
     * The URI of the vocabulary instance to retrieve.
     * @type {string}
     * @memberof VocabularyApiGetVocabularyInstance
     */
    readonly instance: string

    /**
     * The preferred language for the instance data.
     * @type {AcceptedLanguage}
     * @memberof VocabularyApiGetVocabularyInstance
     */
    readonly acceptLanguage?: AcceptedLanguage
}

/**
 * Request parameters for getVocabularyInstances operation in VocabularyApi.
 * @export
 * @interface VocabularyApiGetVocabularyInstancesRequest
 */
export interface VocabularyApiGetVocabularyInstancesRequest {
    /**
     * Gets or sets the URI class, which is a required field.
     * @type {string}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly _class: string

    /**
     * Gets or sets the search term used to filter vocabulary instances.
     * @type {string}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly searchTerm?: string

    /**
     * Gets or sets the language for which the vocabulary instances are requested.
     * @type {AcceptedLanguage}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly language?: AcceptedLanguage

    /**
     * Number of items per page. The maximum number of items per page is &#x60;150&#x60;.
     * @type {number}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly pageSize?: number

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly pageNumber?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof VocabularyApiGetVocabularyInstances
     */
    readonly orderBy?: string
}

/**
 * VocabularyApi - object-oriented interface
 * @export
 * @class VocabularyApi
 * @extends {BaseAPI}
 */
export class VocabularyApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VocabularyApi
     */
    public apiV2VocabulariesOptions(options?: RawAxiosRequestConfig) {
        return VocabularyApiFp(this.configuration).apiV2VocabulariesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves top-level instances from vocabularies.
     * @param {VocabularyApiGetVocabulariesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VocabularyApi
     */
    public getVocabularies(requestParameters: VocabularyApiGetVocabulariesRequest = {}, options?: RawAxiosRequestConfig) {
        return VocabularyApiFp(this.configuration).getVocabularies(requestParameters.searchTerm, requestParameters.language, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Could be a top-level instance, or an intermediate-level instance from a vocabulary.
     * @summary Retrieves a single instance from a vocabulary.
     * @param {VocabularyApiGetVocabularyInstanceRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VocabularyApi
     */
    public getVocabularyInstance(requestParameters: VocabularyApiGetVocabularyInstanceRequest, options?: RawAxiosRequestConfig) {
        return VocabularyApiFp(this.configuration).getVocabularyInstance(requestParameters.instance, requestParameters.acceptLanguage, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves vocabulary instances.
     * @param {VocabularyApiGetVocabularyInstancesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VocabularyApi
     */
    public getVocabularyInstances(requestParameters: VocabularyApiGetVocabularyInstancesRequest, options?: RawAxiosRequestConfig) {
        return VocabularyApiFp(this.configuration).getVocabularyInstances(requestParameters._class, requestParameters.searchTerm, requestParameters.language, requestParameters.pageSize, requestParameters.pageNumber, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }
}

